package enseirb.myinpulse.postgres_db.controller;

import enseirb.myinpulse.postgres_db.model.Administrateurs;
import enseirb.myinpulse.postgres_db.repository.AdministrateursRepository;
import java.util.Optional;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.server.ResponseStatusException;

@RestController
public class AdministrateursController {

    @Autowired AdministrateursRepository administrateursRepository;

    @GetMapping("/Administrateurs")
    @ResponseBody
    public Iterable<Administrateurs> allAdministrateurs() {
        return this.administrateursRepository.findAll();
    }

    @GetMapping("/Administrateurs/{id}")
    public Administrateurs getAdministrateursById(@PathVariable Long id) {
        Optional<Administrateurs> administrateur = this.administrateursRepository.findById(id);
        if (administrateur.isEmpty()) {
            throw new ResponseStatusException(
                    HttpStatus.NOT_FOUND, "Cet administrateur n'existe pas");
        }
        return administrateur.get();
    }

    @PostMapping("/Administrateurs")
    public Administrateurs addAdministrateurs(@RequestBody Administrateurs administrateurs) {
        return this.administrateursRepository.save(administrateurs);
    }
}
