package enseirb.myinpulse.postgres_db.controller;

import enseirb.myinpulse.postgres_db.model.ComptesRendus;
import enseirb.myinpulse.postgres_db.repository.ComptesRendusRepository;
import java.util.Optional;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.server.ResponseStatusException;

@RestController
public class ComptesRendusController {

    @Autowired ComptesRendusRepository comptesRendusRepository;

    @GetMapping("/ComptesRendus")
    @ResponseBody
    public Iterable<ComptesRendus> allComptesRendus() {
        return this.comptesRendusRepository.findAll();
    }

    @GetMapping("/ComptesRendus/{id}")
    public ComptesRendus getComptesRendusById(@PathVariable Long id) {
        Optional<ComptesRendus> compteRendu = this.comptesRendusRepository.findById(id);
        if (compteRendu.isEmpty()) {
            throw new ResponseStatusException(HttpStatus.NOT_FOUND, "Ce compte rendu n'existe pas");
        }
        return compteRendu.get();
    }

    @PostMapping("/ComptesRendus")
    public ComptesRendus addComptesRendus(@RequestBody ComptesRendus comptesRendus) {
        return this.comptesRendusRepository.save(comptesRendus);
    }

    @PostMapping("/ComptesRendus/{id}")
    public ComptesRendus updateProjets(@PathVariable Long id, String contenu_compte_rendu) {
        Optional<ComptesRendus> compteRendu = this.comptesRendusRepository.findById(id);
        if (compteRendu.isEmpty()) {
            throw new ResponseStatusException(HttpStatus.NOT_FOUND, "Ce compte rendu n'existe pas");
        }
        if (contenu_compte_rendu != null) {
            compteRendu.get().setContenu_compte_rendu(contenu_compte_rendu);
        }
        return compteRendu.get();
    }
}
