package enseirb.myinpulse.postgres_db.controller;

import enseirb.myinpulse.postgres_db.model.Entrepreneurs;
import enseirb.myinpulse.postgres_db.repository.EntrepreneursRepository;
import java.util.Optional;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.server.ResponseStatusException;

@RestController
public class EntrepreneursController {

    @Autowired EntrepreneursRepository entrepreneursRepository;

    @GetMapping("/Entrepreneurs")
    @ResponseBody
    public Iterable<Entrepreneurs> allEntrepreneurs() {
        return this.entrepreneursRepository.findAll();
    }

    @GetMapping("/Entrepreneurs/{id}")
    public Entrepreneurs getEntrepreneursById(@PathVariable Long id) {
        Optional<Entrepreneurs> entrepreneur = entrepreneursRepository.findById(id);
        if (entrepreneur.isEmpty()) {
            throw new ResponseStatusException(
                    HttpStatus.NOT_FOUND, "Cet entrepreneur n'existe pas");
        }
        return entrepreneur.get();
    }

    @PostMapping("/Entrepreneurs")
    public Entrepreneurs addEntrepreneurs(@RequestBody Entrepreneurs entrepreneurs) {
        return this.entrepreneursRepository.save(entrepreneurs);
    }

    @PostMapping("/Entrepreneurs/{id}")
    public Entrepreneurs updateEntrepreneurs(
            @PathVariable Long id, String ecole, String filiere, Boolean status_snee) {
        Optional<Entrepreneurs> entrepreneur = entrepreneursRepository.findById(id);
        if (entrepreneur.isEmpty()) {
            throw new ResponseStatusException(
                    HttpStatus.NOT_FOUND, "Cet entrepreneur n'existe pas");
        }
        if (ecole != null) {
            entrepreneur.get().setEcole(ecole);
        }
        if (filiere != null) {
            entrepreneur.get().setFiliere(filiere);
        }
        if (status_snee != null) {
            entrepreneur.get().setStatus_snee(status_snee);
        }
        return entrepreneur.get();
    }
}
