package enseirb.myinpulse.postgres_db.controller;

import enseirb.myinpulse.postgres_db.model.Projets;
import enseirb.myinpulse.postgres_db.repository.ProjetsRepository;
import java.time.LocalDate;
import java.util.Optional;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.server.ResponseStatusException;

@RestController
public class ProjetsController {

    @Autowired ProjetsRepository projetsRepository;

    @GetMapping("/Projets")
    @ResponseBody
    public Iterable<Projets> allProjets() {
        return this.projetsRepository.findAll();
    }

    @GetMapping("/Projets/{id}")
    public Projets getProjetsById(@PathVariable Long id) {
        Optional<Projets> projet = this.projetsRepository.findById(id);
        if (projet.isEmpty()) {
            throw new ResponseStatusException(HttpStatus.NOT_FOUND, "Ce projet n'existe pas");
        }
        return projet.get();
    }

    @PostMapping("/Projets")
    public Projets addProjets(@RequestBody Projets projet) {
        return this.projetsRepository.save(projet);
    }

    @PostMapping("/Projets/{id}")
    public Projets updateProjets(
            @PathVariable Long id,
            String nom_projet,
            byte[] logo,
            LocalDate date_creation,
            String status_projet) {
        Optional<Projets> projet = this.projetsRepository.findById(id);
        if (projet.isEmpty()) {
            throw new ResponseStatusException(HttpStatus.NOT_FOUND, "Ce projet n'existe pas");
        }
        if (nom_projet != null) {
            projet.get().setNom_projet(nom_projet);
        }
        if (logo != null) {
            projet.get().setLogo(logo);
        }
        if (date_creation != null) {
            projet.get().setDate_creation(date_creation);
        }
        if (status_projet != null) {
            projet.get().setStatus_projet(status_projet);
        }
        return projet.get();
    }
}
