package enseirb.myinpulse.postgres_db.controller;

import enseirb.myinpulse.postgres_db.model.RendezVous;
import enseirb.myinpulse.postgres_db.repository.RendezVousRepository;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.util.Optional;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.server.ResponseStatusException;

@RestController
public class RendezVousController {

    @Autowired RendezVousRepository rendezVousRepository;

    @GetMapping("/RendezVous")
    @ResponseBody
    public Iterable<RendezVous> allRendezVous() {
        return this.rendezVousRepository.findAll();
    }

    @GetMapping("/RendezVous/{id}")
    public RendezVous getRendezVousById(@PathVariable Long id) {
        Optional<RendezVous> rendezVous = this.rendezVousRepository.findById(id);
        if (rendezVous.isEmpty()) {
            throw new ResponseStatusException(HttpStatus.NOT_FOUND, "Ce rendez vous n'existe pas");
        }
        return rendezVous.get();
    }

    @PostMapping("/RendezVous")
    public RendezVous addRendezVous(@RequestBody RendezVous rendezVous) {
        return this.rendezVousRepository.save(rendezVous);
    }

    @PostMapping("/RendezVous/{id}")
    public RendezVous updateRendezVous(
            @PathVariable Long id,
            LocalDate date_rdv,
            LocalDateTime heure_rdv,
            LocalDateTime duree_rdv,
            String lieu_rdv,
            String sujet_rdv) {
        Optional<RendezVous> rendezVous = this.rendezVousRepository.findById(id);
        if (rendezVous.isEmpty()) {
            throw new ResponseStatusException(HttpStatus.NOT_FOUND, "Ce rendez vous n'existe pas");
        }
        if (date_rdv != null) {
            rendezVous.get().setDate_rdv(date_rdv);
        }
        if (heure_rdv != null) {
            rendezVous.get().setHeure_rdv(heure_rdv);
        }
        if (duree_rdv != null) {
            rendezVous.get().setDuree_rdv(duree_rdv);
        }
        if (lieu_rdv != null) {
            rendezVous.get().setLieu_rdv(lieu_rdv);
        }
        if (sujet_rdv != null) {
            rendezVous.get().setSujet_rdv(sujet_rdv);
        }
        return rendezVous.get();
    }
}
