package enseirb.myinpulse.postgres_db.controller;

import enseirb.myinpulse.postgres_db.model.Sections;
import enseirb.myinpulse.postgres_db.repository.SectionsRepository;
import java.time.LocalDateTime;
import java.util.Optional;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.server.ResponseStatusException;

@RestController
public class SectionsController {

    @Autowired SectionsRepository sectionsRepository;

    @GetMapping("/Sections")
    @ResponseBody
    public Iterable<Sections> allSections() {
        return this.sectionsRepository.findAll();
    }

    @GetMapping("/Sections/{id}")
    public Sections getSectionsById(@PathVariable Long id) {
        Optional<Sections> section = this.sectionsRepository.findById(id);
        if (section.isEmpty()) {
            throw new ResponseStatusException(HttpStatus.NOT_FOUND, "Cette section n'extise pas");
        }
        return section.get();
    }

    @PostMapping("/Sections")
    public Sections addSections(@RequestBody Sections sections) {
        return this.sectionsRepository.save(sections);
    }

    @PostMapping("/Sections/{id}")
    public Sections updateSections(
            @PathVariable Long id,
            String titre,
            String contenu_section,
            LocalDateTime date_modification) {
        Optional<Sections> section = this.sectionsRepository.findById(id);
        if (section.isEmpty()) {
            throw new ResponseStatusException(HttpStatus.NOT_FOUND, "Cette section n'extise pas");
        }
        if (titre != null) {
            section.get().setTitre(titre);
        }
        if (contenu_section != null) {
            section.get().setContenu_section(contenu_section);
        }
        if (date_modification != null) {
            section.get().setDate_modification(date_modification);
        }
        return section.get();
    }
}
