package enseirb.myinpulse.postgres_db.controller;

import enseirb.myinpulse.postgres_db.model.Utilisateurs;
import enseirb.myinpulse.postgres_db.repository.UtilisateursRepository;
import java.util.Optional;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.server.ResponseStatusException;

@RestController
public class UtilisateursController {

    @Autowired UtilisateursRepository utilisateursRepository;

    @GetMapping("/Utilisateurs")
    @ResponseBody
    public Iterable<Utilisateurs> allUtilisateurs() {
        return this.utilisateursRepository.findAll();
    }

    @GetMapping("/Utilisateurs/{id}")
    public Utilisateurs getUtilisateursById(@PathVariable Long id) {
        Optional<Utilisateurs> utilisateur = utilisateursRepository.findById(id);
        if (utilisateur.isEmpty()) {
            throw new ResponseStatusException(HttpStatus.NOT_FOUND, "Cet utilisateur n'existe pas");
        }
        return utilisateur.get();
    }

    @PostMapping("/Utilisateurs")
    public Utilisateurs addUtilisateurs(@RequestBody Utilisateurs utilisateurs) {
        return this.utilisateursRepository.save(utilisateurs);
    }

    @PostMapping("/Utilisateurs/{id}")
    public Utilisateurs updateUtilisateurs(
            @PathVariable Long id,
            String nom_utilisateur,
            String prenom_utilisateur,
            String mail_principal,
            String mail_secondaire,
            String numero_telephone) {
        Optional<Utilisateurs> utilisateur = utilisateursRepository.findById(id);
        if (utilisateur.isEmpty()) {
            throw new ResponseStatusException(HttpStatus.NOT_FOUND, "Cet utilisateur n'existe pas");
        }
        if (nom_utilisateur != null) {
            utilisateur.get().setNom_utilisateur(nom_utilisateur);
        }
        if (prenom_utilisateur != null) {
            utilisateur.get().setPrenom_utilisateur(prenom_utilisateur);
        }
        if (mail_principal != null) {
            utilisateur.get().setMail_principal(mail_principal);
        }
        if (mail_secondaire != null) {
            utilisateur.get().setMail_secondaire(mail_secondaire);
        }
        if (numero_telephone != null) {
            utilisateur.get().setNumero_telephone(numero_telephone);
        }
        return utilisateur.get();
    }
}
