package enseirb.myinpulse.postgres_db.model;

import jakarta.persistence.*;
import jakarta.validation.constraints.NotNull;
import java.time.LocalDate;
import java.util.ArrayList;
import java.util.List;

@Entity
@Table(name = "projets")
public class Projets {

    @Id
    @NotNull
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id_projet;

    @Column(length = 255)
    private String nom_projet;

    private byte[] logo;

    private LocalDate date_creation;

    @Column(length = 255)
    private String status_projet;

    @OneToMany(mappedBy = "projetsAdministrateurs", fetch = FetchType.LAZY, orphanRemoval = true)
    private List<Administrateurs> listAdministrateurs = new ArrayList<>();

    @OneToMany(mappedBy = "projetsParticipation", fetch = FetchType.LAZY, orphanRemoval = true)
    private List<Entrepreneurs> ListEntrepreneursParticipation = new ArrayList<>();

    @OneToOne(mappedBy = "projetsPropose", fetch = FetchType.LAZY, orphanRemoval = true)
    private Entrepreneurs entrepreneursPropose;

    @OneToMany(mappedBy = "projetsSections", fetch = FetchType.LAZY, orphanRemoval = true)
    private List<Sections> ListSections = new ArrayList<>();

    // Hibernate expects entities to have a no-arg constructor,
    // though it does not necessarily have to be public.

    public Projets() {}

    public Projets(
            Long id_projet,
            String nom_projet,
            byte[] logo,
            LocalDate date_creation,
            String status_projet) {
        this.id_projet = id_projet;
        this.nom_projet = nom_projet;
        this.logo = logo;
        this.date_creation = date_creation;
        this.status_projet = status_projet;
    }

    public Long getId_projet() {
        return id_projet;
    }

    public void setId_projet(Long id_projet) {
        this.id_projet = id_projet;
    }

    public String getNom_projet() {
        return nom_projet;
    }

    public void setNom_projet(String nom_projet) {
        this.nom_projet = nom_projet;
    }

    public byte[] getLogo() {
        return logo;
    }

    public void setLogo(byte[] logo) {
        this.logo = logo;
    }

    public LocalDate getDate_creation() {
        return date_creation;
    }

    public void setDate_creation(LocalDate date_creation) {
        this.date_creation = date_creation;
    }

    public String getStatus_projet() {
        return status_projet;
    }

    public void setStatus_projet(String status_projet) {
        this.status_projet = status_projet;
    }
}
