package enseirb.myinpulse.postgres_db.model;

import jakarta.persistence.*;
import jakarta.validation.constraints.NotNull;

import java.time.LocalDateTime;
import java.util.ArrayList;
import java.util.List;

@Entity
@Table(name = "sections")
public class Sections {

    @Id
    @NotNull
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id_section;

    @Column(length = 255)
    private String titre;

    private String contenu_section;

    private LocalDateTime date_modification;

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "id_projet")
    private Projets projetsSections;

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "id_admnistrateur")
    private Administrateurs administrateursSections;

    @ManyToMany(mappedBy = "ListSections")
    private List<RendezVous> rendezVous = new ArrayList<>();

    public Sections() {}

    public Sections(
            Long id_section,
            String titre,
            String contenu_section,
            LocalDateTime date_modification) {
        this.id_section = id_section;
        this.titre = titre;
        this.contenu_section = contenu_section;
        this.date_modification = date_modification;
    }

    public String getTitre() {
        return titre;
    }

    public void setTitre(String titre) {
        this.titre = titre;
    }

    public Long getId_section() {
        return id_section;
    }

    public void setId_section(Long id_section) {
        this.id_section = id_section;
    }

    public String getContenu_section() {
        return contenu_section;
    }

    public void setContenu_section(String contenu_section) {
        this.contenu_section = contenu_section;
    }

    public LocalDateTime getDate_modification() {
        return date_modification;
    }

    public void setDate_modification(LocalDateTime date_modification) {
        this.date_modification = date_modification;
    }
}
